diff --git a/lib/inet6_gr.c b/lib/inet6_gr.c
index 72b4a66..2361809 100644
--- a/lib/inet6_gr.c
+++ b/lib/inet6_gr.c
@@ -23,7 +23,7 @@
 #include <string.h>
 #include <stdio.h>
 #include <unistd.h>
-#ifndef __GLIBC__
+#ifdef HAVE_IPV6_ROUTE_H
 #include <netinet6/ipv6_route.h>	/* glibc doesn't have this */
 #endif
 #include "version.h"
diff --git a/lib/inet6_sr.c b/lib/inet6_sr.c
index 1ad9510..96dbd5f 100644
--- a/lib/inet6_sr.c
+++ b/lib/inet6_sr.c
@@ -23,10 +23,10 @@
 #include <string.h>
 #include <stdio.h>
 #include <unistd.h>
-#ifdef __GLIBC__
-#include <net/route.h>
-#else
+#ifdef HAVE_IPV6_ROUTE_H
 #include <netinet6/ipv6_route.h>	/* glibc does not have this */
+#else
+#include <net/route.h>
 #endif
 #include "version.h"
 #include "net-support.h"
diff --git a/lib/inet_sr.c b/lib/inet_sr.c
index 1a876ae..6a26a76 100644
--- a/lib/inet_sr.c
+++ b/lib/inet_sr.c
@@ -26,6 +26,7 @@
 #include <string.h>
 #include <stdio.h>
 #include <unistd.h>
+#include <asm-generic/param.h>
 #include "version.h"
 #include "net-support.h"
 #include "pathnames.h"
diff --git a/lib/util-ank.c b/lib/util-ank.c
index b077f35..4ee59f6 100644
--- a/lib/util-ank.c
+++ b/lib/util-ank.c
@@ -14,6 +14,7 @@
  * Rani Assaf <rani@magic.metawire.com> 980929:	resolve addresses
  */
 
+#include <limits.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <unistd.h>
diff --git a/mii-tool.c b/mii-tool.c
index 1cfecc2..fbc3b34 100644
--- a/mii-tool.c
+++ b/mii-tool.c
@@ -46,10 +46,6 @@
 #include <net/if.h>
 #include <linux/sockios.h>
 
-#ifndef __GLIBC__
-#include <linux/if_arp.h>
-#include <linux/if_ether.h>
-#endif
 #include <linux/mii.h>
 #include <linux/sockios.h>
 #include "version.h"
diff --git a/netstat.c b/netstat.c
index d0c364f..8453f18 100644
--- a/netstat.c
+++ b/netstat.c
@@ -88,6 +88,7 @@
 #include <sys/stat.h>
 #include <net/if.h>
 #include <dirent.h>
+#include <asm-generic/param.h>
 
 #include "net-support.h"
 #include "pathnames.h"
diff --git a/slattach.c b/slattach.c
index 5c81584..3ccde28 100644
--- a/slattach.c
+++ b/slattach.c
@@ -44,6 +44,7 @@
 #include <string.h>
 #include <unistd.h>
 #include <getopt.h>
+#include <termios.h>
 #include <linux/if_slip.h>
 
 #if defined(__GLIBC__)
